import java.util.Random;



/**
 * Assignment #3: See the assignment posted on Ctools. You have to complete the code for this class. Base code
 * provided by Atul Prakash.
 * 
 * @author  Add your name
 */

enum Sex {M, F};

public class Monkey {
	static int nextID = 0;
	private Monkey mom;          /* this monkey's mom. null if unknown */
	private Monkey dad;          /* this monkey's dad. null if unknown */
	private int ID;              /* A unique ID for this monkey. */
	private Sex sex;             /* male or female? */
	private Monkey[] children;   /* list of children of this monkey. numChildren tells you how many elements are valid */
	private int numChildren;     /* number of children. Use in conjunction with children array */
	private int yearofbirth;     /* year in which the monkey was born. Higher yearofbirth means younger monkey */
	
	static int MAX_CHILDREN = 10;  /* Maximum number of children that can be stored per monkey in the children array */
	
	/**
	 * Create a monkey instance. The constructor should set the ID value to the next available ID. Available ID
	 * value should go up by 1 every time a monkey is created, starting from 0.
	 * It should also initialize other values, such as children, numChildren, etc.
	 * testinvariants() should be called at the end of this method to make sure that the class invariants
	 * are established correctly when an object is created.
	 * @param	sex	the sex of the new monkey. Values Monkey.Sex.M or Monkey.Sex.F
	 * @param	year	he year in which the monkey was born. A value >= 0
	 */
	public Monkey( Sex sex, int year) {
		// add your code here 
		
		testInvariants();
	}
	
	/**
	 * Set/replace a monkey's mom. If an illegal monkey is given (e.g., younger or same age, male monkey), you should ignore the request.
	 * Make sure you call testInvariants() at the start and end of the method to make sure you maintain the invariants.
	 * @param	mom	This monkey's mom should be set to the the specified parameter. 
	 */
	public void setMom(Monkey mom) {
		testInvariants();
		// add your code here. If exiting in the middle after modifying state, remember to check invariants there.
		
		

		testInvariants();
		mom.testInvariants(); // Good idea to do this as well.
	}
	
	/**
	 * @return the mom of this monkey. If no mom set, returns null.
	 */
	public Monkey getMom() {
		return mom;
	}
	
	/* Add Javadoc style comment for this. Similar specs as setMom */
	public void setDad(Monkey dad) {
		testInvariants();
		// add your code here. If exiting in the middle after modifying state, remember to check invariants there.
		
		
		testInvariants();
		dad.testInvariants();
	}
	

	
	/* Add Javadoc style comment for this */
	
	public Monkey getDad() {
		return dad;
	}


	/**
	 * Remove the mom for this monkey. This method may be necessary if the mom was incorrectly set previously.
	 * This should also cause the monkey to be removed from the list of children for the mom.
	 * Should do nothing if the monkey does not have a mom.
	 */
	public void unsetMom() {
		testInvariants();
		Monkey oldmom = mom;
		if (mom != null) mom.removeChild(this);
		testInvariants();
		if (oldmom != null) oldmom.testInvariants();
	}
	
	/* Similar to unsetMom. Add Javadoc-style comment */
	public void unsetDad() {
		Monkey olddad = dad;
		testInvariants();
		if (dad != null) dad.removeChild(this);
		testInvariants();
		if (olddad != null) olddad.testInvariants();
	}
	
	/**
	 * @return the unique ID assigned to this monkey. The ID is auto-assigned by the constructor.
	 */
	public int getID() {
		return ID;
	}
	
	
	/**
	 * @param child
	 * @return true if the parameter child is one of this monkey's children; else returns false.
	 */
	public boolean isChild(Monkey child) {
		// add your code here. The return statement below is a stub so that Eclipse does not complain.
		// Feel free to change it.
		
		return false;
	}
	
	/**
	 * This method adds a child "child" for this monkey. The method should return without adding
	 * a child if the given child monkey is same age or older. It should also return without adding
	 * if the number of children is at the MAX_CHILDREN limit.
	 * @param	child	child to be added
	 */
	public void addChild(Monkey child) {
		testInvariants();
		// Add your code here
		
	
		testInvariants();
	}

	
	/* (non-Javadoc) This method permits a monkey's state to be printed as a string using System.out.println(monkey)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		String result;
		result = Integer.toString(ID) + ":";
		if (mom != null) result += " Mom = " + Integer.toString(mom.getID());
		else result += "Mom = UNKNOWN";
		if (dad != null) result += " Dad = " + Integer.toString(dad.getID());
		else result += " Dad = UNKNOWN";
		if (sex == Sex.M) result += " Sex = Male";
		else result += " Sex = Female";
		result += " Born = " + Integer.toString(yearofbirth);
		result += " Number of children = " + numChildren + "\n";
		result += " Children are: ";
		for (int i = 0; i < numChildren; i++) {
			result += children[i].getID() + " ";
		}
		return result;
	}
	
	
	/**
	 * @return the sex of the monkey. Possible values: Sex.M or Sex.F
	 */
	public Sex getSex() {
		return sex;
	}
		
	/**
	 * This method should contain a lot of checks using assertions that test the correctness of
	 * values and relationships in this monkey. We we give one example below.
	 * The invariants you should test for are given in the assignment handout.
	 */
	public void testInvariants() {
		if (mom != null) {
			assert(mom.isChild(this));
		}
		
		
		
	}
		

	/**
	 * @param child
	 * 
	 * This removes the specified parameter from the children's list of this monkey. It should also update the
	 * state of the child, if necessary, so that the invariants are maintained. If the child paramter is not a child
	 * of this monkey, this method should return without changing the state of the monkey.
	 */
	public void removeChild(Monkey child) {
		testInvariants();
		// add your code. Remember to check assertions and invariants before exiting from this method if
		// modify state.
		
		
		assert(!isChild(child));
		testInvariants();
	}
	
	/**
	 * @return the number of children of this monkey
	 */
	public int getNumChildren() {
		return numChildren;
	}
	
	
	/**
	 * @return the yearofbirth value
	 */
	public int getYearofbirth() {
		return yearofbirth;
	}

	// Below this point, you can add additional tests. You should keep the tests that we have provided to you.
	// There are several aspects these do not currently test for - for example, what happens if we attempt 
	// to add too many children to a monkey. Furthermore,our tests do not test all the methods. We expect you to 
	// add additional tests that help test for
	// situations not covered by our tests. In the comments, indicate the behavior that your tests test
	// for clearly and why the test provides value beyond the existing tests.
	
	/**
	 * Generates a large number  monkeys with random year of births and random sex. Then establish
	 * a random set of child-parent relationships among them. Use assertions to check that the
	 * class is working as desired.
	 */
	public static void stressTest() {
	// Generate 1000  monkeys with increasing year of births between 1800 and 2010.
	// For each monkey, choose a random sex and a randomly chosen mom or dad from the already generated monkeys, 
    // including a possible null value, indicating an unknown mom or dad.  
	// This is not representative of the real world, but it will do for 
	// testing.
		int COUNT = 10000;
		int RELATIONSHIPS = 20000;
		Monkey[] monkeys = new Monkey[COUNT];
		Random r = new Random();
		// Generate COUNT monkeys
		for (int i = 0; i < COUNT; i++) {
			int year = r.nextInt(15);
			Sex sex;
			int ismale = r.nextInt(2);
			if (ismale == 1) sex = Sex.M;
			else {
				assert(ismale == 0);
				sex = Sex.F;
			}
			monkeys[i] = new Monkey(sex, year);
			monkeys[i].testInvariants();
		}
		
		// generate random parent-child relationships
		for (int i = 0; i < RELATIONSHIPS; i++) {
			// try creating parental relationships between two arbitrary monkeys
			int i1 = r.nextInt(COUNT);
			int i2 = r.nextInt(COUNT);
			Monkey m1 = monkeys[i1];
			Monkey m2 = monkeys[i2];
			if (m1 == m2) continue;
			m1.testInvariants();
			m2.testInvariants();
			if (m1.getNumChildren() < Monkey.MAX_CHILDREN) {
				m1.addChild(m2);   // This may not always succeed, if m1's year is >= m2.
				System.out.println("Adding " + m2 + "as a child of " + m1);
			}
			else continue;
			if (m1.getYearofbirth() < m2.getYearofbirth()) {
				assert(m1.isChild(m2));
				// m1 must be a parent of m2. Do the check.
				assert((m1.sex == Sex.M && m2.getDad() == m1) || (m1.sex == Sex.F && m2.getMom() == m1));
			} else {
				assert(!m1.isChild(m2));  // m1 is younger or equal age as m2. Cannot be a parent of m2.
			}
			m1.testInvariants();
			m2.testInvariants();
			if (m2.getDad() != null) m2.getDad().testInvariants();
			if (m2.getMom() != null) m2.getMom().testInvariants();
		}
		
		// Check all the monkeys that they observe the class invariants and that IDs are assigned correctly
		for (int i = 0; i < COUNT; i++) {
			monkeys[i].testInvariants();
			assert(monkeys[i].getID() - monkeys[0].getID() == i);
		}
		
		System.out.println("Stress test passed");
		
		System.out.println("Printing all the monkeys");
		for (int i = 0; i < COUNT; i++) {
			System.out.println(monkeys[i]);
		}
	}
	
	

	/**
	 * Creates a small number of monkeys, add a few relationships, and then does some basic tests.
	 */
	public static void testAddingRelations() {
		Monkey m1 = new Monkey(Sex.M, 1900);
		Monkey m2 = new Monkey(Sex.F, 1901);
		Monkey m3 = new Monkey(Sex.F, 1904);
		Monkey m4 = new Monkey(Sex.M, 1906);
		Monkey m5 = new Monkey(Sex.F, 1908);
		m3.setMom(m2);
		m3.setDad(m1);
		m3.addChild(m4);
		assert(m2.isChild(m3));
		assert(m4.getMom() == m3);
		assert(m3.getDad() == m1);
		assert(m1.isChild(m3));
		m1.testInvariants();
		m2.testInvariants();
		m3.testInvariants();
		m4.testInvariants();
		m5.testInvariants();
		System.out.println("TestAddingRelations passed");
		
	}
	
	
	
	/**
	 * Creates a small number of monkeys, add.removes a few relationships, and then does some basic tests.
	 */
	public static void testRemovingRelations() {
		Monkey m1 = new Monkey(Sex.M, 1900);
		Monkey m2 = new Monkey(Sex.F, 1901);
		Monkey m3 = new Monkey(Sex.F, 1904);
		Monkey m4 = new Monkey(Sex.M, 1906);
		Monkey m5 = new Monkey(Sex.F, 1908);
		m3.setMom(m2);
		m3.setDad(m1);
		m3.addChild(m4);
		m3.removeChild(m4);
		assert(m4.getMom() == null);
		assert(m4.getDad() == null);
		assert(!m3.isChild(m4));
		m1.testInvariants();
		m2.testInvariants();
		m3.testInvariants();
		m4.testInvariants();
		m5.testInvariants();
		System.out.println("TestRemovingRelations passed");
	}
	
	



	public static void main(String[] args) {
		// Uncomment the tests when you are ready to run the code.
		/*
		testAddingRelations();
		testRemovingRelations();
		stressTest();
		*/
	}

}
